/*-----------------------------------------------------------------------
				FedTerm version 1.60 - Windows Federation 2 Client
			  Copyright (c) 1995-2006 Interactive Broadcasting Ltd

	This program is free software: you can redistribute it and /or modify 
	it under the terms of the GNU General Public License as published by 
	the Free Software Foundation: either version 2 of the License, or (at 
	your option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY: without even the implied warranty of 
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
	General Public License for more details.

	You should have received a copy of the GNU General Public License 
	along with this program; if not, write to the Free Software Foundation, 
	Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307 USA

	Program written and compiled with Borland C++ Builder 5
	Programming and design: 	Alan Lenton
	Home website:					www.ibgames.net
-----------------------------------------------------------------------*/

#include <vcl.h>
#pragma hdrstop

#include <sstream>
#include <io.h>

#include "exchange.h"
#include "main.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------

void	Exchange::ExchangeBuy(const std::string&name,int price)
{
	std::ostringstream	buffer;
	buffer << ".\\pictures\\" << name << ".bmp";
	if(access(buffer.str().c_str(),0) == 0)
		MainForm->ExchImage->Picture->LoadFromFile(buffer.str().c_str());
	else
	{
		if(access(".\\pictures\\exchange.bmp",0) == 0)
			MainForm->ExchImage->Picture->LoadFromFile(".\\pictures\\exchange.bmp");
	}
	MainForm->CommodNameLabel->Caption = name.c_str();
	buffer.str("");
	buffer << "Exch buys at " << price << "/ton";
	MainForm->CommodLabel1->Caption = buffer.str().c_str();
	MainForm->CommodLabel2->Caption = "";
	buffer.str("");
	buffer << "Exch buys " << name << " at " << price << "/ton";
	MainForm->HistoryListBox->Items->Insert(0,buffer.str().c_str());
	if(MainForm->HistoryListBox->Items->Count > 100)
		MainForm->HistoryListBox->Items->Delete(100);
//	MainForm->HistoryListBox->Hint = buffer.str().c_str();
	buffer.str("");
	buffer << "+++ Exchange buys " << name << " at " << price << "/ton +++";
	MainForm->ExchangeTicker(buffer.str());
}

void	Exchange::ExchangeSell(const std::string&name,int price,int stock)
{
	std::ostringstream	buffer;
	buffer << ".\\pictures\\" << name << ".bmp";
	if(access(buffer.str().c_str(),0) == 0)
		MainForm->ExchImage->Picture->LoadFromFile(buffer.str().c_str());
	else
	{
		if(access(".\\pictures\\exchange.bmp",0) == 0)
			MainForm->ExchImage->Picture->LoadFromFile(".\\pictures\\exchange.bmp");
	}
	MainForm->CommodNameLabel->Caption = name.c_str();
	buffer.str("");
	buffer << stock << " tons available";
	MainForm->CommodLabel1->Caption = buffer.str().c_str();
	buffer.str("");
	buffer << "Exch sells at " << price << "/ton";
	MainForm->CommodLabel2->Caption = buffer.str().c_str();
	buffer.str("");
	buffer << "Exch sells " << name << " at " << price << "/ton (" << stock << ")";
	MainForm->HistoryListBox->Items->Insert(0,buffer.str().c_str());
	if(MainForm->HistoryListBox->Items->Count > 100)
		MainForm->HistoryListBox->Items->Delete(100);
//	MainForm->HistoryListBox->Hint = buffer.str().c_str();
	buffer.str("");
	buffer << "+++ Exchange sells " << name << " at " << price << "/ton +++";
	MainForm->ExchangeTicker(buffer.str());
}

void	Exchange::Initialise(const std::string& name)
{
	if(access(".\\pictures\\exchange.bmp",0) == 0)
		MainForm->ExchImage->Picture->LoadFromFile(".\\pictures\\exchange.bmp");
	MainForm->TopNotebook->ActivePage = MainForm->ExchTab;
	std::string	buffer = " " + name + " Commodity Exchange ";
	MainForm->LastExchGroup->Caption = buffer.c_str();
	MainForm->CommodNameLabel->Caption = "";
	MainForm->CommodLabel1->Caption = "";
	MainForm->CommodLabel2->Caption = "";
	MainForm->TickerEdit->Text = "";
	MainForm->HistoryListBox->Clear();
	MainForm->HistoryListBox->Hint = "Double click on an entry to buy or sell that commodity";
}

void	Exchange::Transaction(std::string& which)
{
	std::ostringstream	buffer;
	if(which[5] == 's')
		buffer << ">buy ";
	else
		buffer << ">sell ";
	std::string::size_type	start = which.find(" ",5);
	if(start == std::string::npos)
		return;
	std::string::size_type	end = which.find(" ", start + 1);
	if(end == std::string::npos)
		return;
	buffer << which.substr(start + 1,end - (start + 1)); // << "\n";
	std::string	text(buffer.str());
	MainForm->OutputText(text);
	text.erase(0,1);
	text += "\n";
	MainForm->Send(text);
}


