/*-----------------------------------------------------------------------
				FedTerm version 1.60 - Windows Federation 2 Client
			  Copyright (c) 1995-2006 Interactive Broadcasting Ltd

	This program is free software: you can redistribute it and /or modify 
	it under the terms of the GNU General Public License as published by 
	the Free Software Foundation: either version 2 of the License, or (at 
	your option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY: without even the implied warranty of 
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
	General Public License for more details.

	You should have received a copy of the GNU General Public License 
	along with this program; if not, write to the Free Software Foundation, 
	Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307 USA

	Program written and compiled with Borland C++ Builder 5
	Programming and design: 	Alan Lenton
	Home website:					www.ibgames.net
-----------------------------------------------------------------------*/

#ifndef FEDMAP_H
#define FEDMAP_H

#include <map>
#include <string>

#include <Grids.hpp>

#include "xml.h"

class Infra;
class Location;

typedef std::map<int,Location *,std::less<int> >	LocIndex;

class	FedMap
{
public:
	static const int MAP_SIZE;

private:
	Graphics::TBitmap	*map_gfx;	// The tileset for the map

	Infra	*infra;						// Infrastrucutre info
	LocIndex		loc_index;			// STL map of visited locations
	int			current_loc;		// Where our player is now

	int	CheckDiagonalLink(int col,int row);
	int	CheckLeftRightLink(int col,int row);
	int	CheckUpDownLink(int col,int row);

	bool	CheckExit(int col,int row,int dir);

	void	LoadMapGfx();

public:
	FedMap();
	~FedMap();

	const std::string&	MakeMapFileName();
	bool	Load();

	void	AddLoc(Location *loc,bool update = true);
	void	AddFactory(const AttribList& attrib);
	void	CentreMap(int loc_no,TDrawGrid *grid);
	void	Clear();
	void	DisplayInfra();
	void	DrawCell(int col,int row,TRect &rect,TDrawGrid *grid);
	void	MapInfo(const AttribList& attrib);
	void	MovementKeys(WORD &key);
	void	Name2Status(int col,int row);
	void	NewMap(const AttribList& attrib);
	void	RemoveFactory(const AttribList& attrib);
	void	Write();
	void	UpdateWorkers(const AttribList& attrib);
};

#endif

