/*-----------------------------------------------------------------------
				FedTerm version 1.60 - Windows Federation 2 Client
			  Copyright (c) 1995-2006 Interactive Broadcasting Ltd

	This program is free software: you can redistribute it and /or modify 
	it under the terms of the GNU General Public License as published by 
	the Free Software Foundation: either version 2 of the License, or (at 
	your option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY: without even the implied warranty of 
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
	General Public License for more details.

	You should have received a copy of the GNU General Public License 
	along with this program; if not, write to the Free Software Foundation, 
	Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307 USA

	Program written and compiled with Borland C++ Builder 5
	Programming and design: 	Alan Lenton
	Home website:					www.ibgames.net
-----------------------------------------------------------------------*/

#include <vcl.h>
#pragma hdrstop

#include "friends.h"

#include "fed2.h"
#include "friends_code.h"
#include "main.h";
#include "players.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFriendsForm *FriendsForm;
//---------------------------------------------------------------------------

__fastcall TFriendsForm::TFriendsForm(TComponent* Owner)
	: TForm(Owner)
{
}


void __fastcall TFriendsForm::AddBtnClick(TObject *Sender)
{
	if(NewEdit->Text.Length() == 0)
		return;
	std::string	name(NewEdit->Text.c_str());
	NewEdit->Text = "";
	name.erase(name.length());
	AddName(name);
}

void	TFriendsForm::AddName(const std::string& name)
{
	int index = FriendsList->Items->IndexOf(name.c_str());
	if(index < 0)
		FriendsList->Items->Add(name.c_str());
}

void __fastcall TFriendsForm::CancelBtnClick(TObject *Sender)
{
	Close();
}

void	TFriendsForm::Clear()
{
	FriendsList->Clear();
	NewEdit->Clear();
	AudioCheck->Checked = false;

	GHogCheck->Checked =  			false;
	CommanderCheck->Checked =  	false;
	CaptainCheck->Checked =  		false;
	AdventCheck->Checked =  		false;

	MerchantCheck->Checked =	  	false;
	TraderCheck->Checked =  		false;
	IndustrialistCheck->Checked = false;
	ManufacturerCheck->Checked =  false;
	FinancierCheck->Checked =  	false;

	FounderCheck->Checked =  		false;
	EngineerCheck->Checked =  		false;
	MogulCheck->Checked =  			false;
	TechnoCheck->Checked =  		false;
	MagnateCheck->Checked =  		false;
	PlutocratCheck->Checked =  	false;
	SyndicratCheck->Checked =  	false;
}

void __fastcall TFriendsForm::DeleteBtnClick(TObject *Sender)
{
	int	index = FriendsList->ItemIndex;
	if(index >= 0)
		FriendsList->Items->Delete(index);
	else
		MessageDlg("You need to select a player first!",mtError,TMsgDlgButtons() << mbOK,0);
}

void __fastcall TFriendsForm::FormShow(TObject *Sender)
{
	Fed2::friends->UpdateForm();
}

void __fastcall TFriendsForm::OKBtnClick(TObject *Sender)
{
	Fed2::friends->GetInfo();
	Close();
}

void	TFriendsForm::SetRank(int which)
{
	switch(which)
	{
		case Friends::GROUNDHOG:		GHogCheck->Checked =  			true;   break;
		case Friends::COMMANDER:		CommanderCheck->Checked =  	true;   break;
		case Friends::CAPTAIN:			CaptainCheck->Checked =  		true;   break;
		case Friends::ADVENTURER:		AdventCheck->Checked =  		true;   break;
		case Friends::MERCHANT:			MerchantCheck->Checked =  		true;   break;
		case Friends::TRADER:			TraderCheck->Checked =  		true;   break;
		case Friends::INDUSTRIALIST:	IndustrialistCheck->Checked = true;   break;
		case Friends::MANUFACTURER:	ManufacturerCheck->Checked =  true;   break;
		case Friends::FINANCIER:		FinancierCheck->Checked =  	true;   break;
		case Friends::FOUNDER:			FounderCheck->Checked =  		true;   break;
		case Friends::ENGINEER:			EngineerCheck->Checked =  		true;   break;
		case Friends::MOGUL:				MogulCheck->Checked =  			true;   break;
		case Friends::TECHNOCRAT:		TechnoCheck->Checked =  		true;   break;
		case Friends::MAGNATE:			MagnateCheck->Checked =  		true;   break;
		case Friends::PLUTOCRAT:		PlutocratCheck->Checked =  	true;   break;
		case Friends::SYNDICRAT:		SyndicratCheck->Checked =  	true;   break;
	}
}




