/*-----------------------------------------------------------------------
				FedTerm version 1.60 - Windows Federation 2 Client
			  Copyright (c) 1995-2006 Interactive Broadcasting Ltd

	This program is free software: you can redistribute it and /or modify 
	it under the terms of the GNU General Public License as published by 
	the Free Software Foundation: either version 2 of the License, or (at 
	your option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY: without even the implied warranty of 
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
	General Public License for more details.

	You should have received a copy of the GNU General Public License 
	along with this program; if not, write to the Free Software Foundation, 
	Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307 USA

	Program written and compiled with Borland C++ Builder 5
	Programming and design: 	Alan Lenton
	Home website:					www.ibgames.net
-----------------------------------------------------------------------*/

#ifndef LOCATION_H
#define LOCATION_H

#include	<bitset>
#include <fstream>
#include <string>

#include "xml.h"    	// can't seem to forward declare AttribList :(

class Location
{
public:
	static const int TILE_SIZE;
	enum	{	NORTH, NE, EAST, SE, SOUTH, SW, WEST, NW, UP, DOWN, MAX_EXITS	};

private:
	static const std::string	exit_names[];

	std::string					name;		// the location name
	int							x, y;		// column (x) and row (y)
	std::bitset<MAX_EXITS>	exits;	// bit is set if there is an exit

public:
	Location(const AttribList& attrib);
	~Location()		{	}

	int	LocNum();
	const std::string	&Name()			{ return(name);	}

	bool	IsAnExit(int dir)				{ return(exits.test(dir));	}

	void 	Name2LocOutput();
	void 	Name2TextOutput();
	void	Dump();
	void	Write(std::ofstream& file);
};

#endif

