/*-----------------------------------------------------------------------
				FedTerm version 1.60 - Windows Federation 2 Client
			  Copyright (c) 1995-2006 Interactive Broadcasting Ltd

	This program is free software: you can redistribute it and /or modify 
	it under the terms of the GNU General Public License as published by 
	the Free Software Foundation: either version 2 of the License, or (at 
	your option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY: without even the implied warranty of 
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
	General Public License for more details.

	You should have received a copy of the GNU General Public License 
	along with this program; if not, write to the Free Software Foundation, 
	Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307 USA

	Program written and compiled with Borland C++ Builder 5
	Programming and design: 	Alan Lenton
	Home website:					www.ibgames.net
-----------------------------------------------------------------------*/

#include <vcl.h>
#pragma hdrstop

#include "macro_rec.h"

#include "macroform.h"
#include "main.h"
#include "xml.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------

void	MacroRec::Add(const std::string& line)
{
	commands.push_back(line);
}

void	MacroRec::Clear()
{
	commands.clear();
}

void	MacroRec::Display()
{
	MacroBox->FKeyMemo->Clear();
	for(CmdList::iterator iter = commands.begin();iter != commands.end();iter++)
		MacroBox->FKeyMemo->Lines->Add((*iter).c_str());
	MacroBox->FKeyMemo->Modified = false;
}

void	MacroRec::Send()
{
	std::string	temp;
	for(CmdList::iterator iter = commands.begin();iter != commands.end();iter++)
	{
		temp = *iter + '\n';
		MainForm->Send(temp);
	}
}

void	MacroRec::Transfer(TMemo *memo)
{
	for(CmdList::iterator iter = commands.begin();iter != commands.end();iter++)
		memo->Lines->Add((*iter).c_str());
}

void	MacroRec::Update(TMemo *memo)
{
	Clear();
	int num_lines = memo->Lines->Count;
	for(int count = 0;count < num_lines;count++)
	{
		if(memo->Lines->Strings[count].Length() > 0)
			commands.push_back(memo->Lines->Strings[count].c_str());
	}
}

void	MacroRec::Write(std::ofstream& file)
{
	for(CmdList::iterator iter = commands.begin();iter != commands.end();iter++)
		file << "      <command>" << XMLParser::EscapeXML(*iter) << "</command>\n";
}





