/*-----------------------------------------------------------------------
				FedTerm version 1.60 - Windows Federation 2 Client
			  Copyright (c) 1995-2006 Interactive Broadcasting Ltd

	This program is free software: you can redistribute it and /or modify 
	it under the terms of the GNU General Public License as published by 
	the Free Software Foundation: either version 2 of the License, or (at 
	your option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY: without even the implied warranty of 
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
	General Public License for more details.

	You should have received a copy of the GNU General Public License 
	along with this program; if not, write to the Free Software Foundation, 
	Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307 USA

	Program written and compiled with Borland C++ Builder 5
	Programming and design: 	Alan Lenton
	Home website:					www.ibgames.net
-----------------------------------------------------------------------*/

#ifndef MACROREC_H
#define MACROREC_H

#include <stdctrls.hpp>

#include <fstream>
#include <list>
#include <string>

typedef	std::list<std::string>		CmdList;

class MacroRec
{
private:
	CmdList	commands;		// list of the commands to be executed

public:
	MacroRec()	{	}
	~MacroRec()	{	}

	void	Add(const std::string& line);
	void	Clear();
	void	Display();
	void	Send();
	void	Transfer(TMemo *memo);
	void	Update(TMemo *memo);
	void	Write(std::ofstream&	file);
};

#endif
