/*-----------------------------------------------------------------------
				FedTerm version 1.60 - Windows Federation 2 Client
			  Copyright (c) 1995-2006 Interactive Broadcasting Ltd

	This program is free software: you can redistribute it and /or modify 
	it under the terms of the GNU General Public License as published by 
	the Free Software Foundation: either version 2 of the License, or (at 
	your option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY: without even the implied warranty of 
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
	General Public License for more details.

	You should have received a copy of the GNU General Public License 
	along with this program; if not, write to the Free Software Foundation, 
	Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307 USA

	Program written and compiled with Borland C++ Builder 5
	Programming and design: 	Alan Lenton
	Home website:					www.ibgames.net
-----------------------------------------------------------------------*/

#include <vcl.h>
#pragma hdrstop

#include "map_parser.h"

#include "fedmap.h"
#include "fed2.h"
#include "location.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------

const int			MapParser::NOT_AN_ELEMENT = -1;
const std::string	MapParser::elements[] = { "map", "loc", ""	};

MapParser::~MapParser()
{
	// avoiding inline virtual destructors
}


int	MapParser::FindElement(const std::string& elem)
{
	for(int count = 0;elements[count] != "";count++)
	{
		if(elements[count] == elem)
			return(count);
	}
	return(NOT_AN_ELEMENT);
}

void	MapParser::NewLoc(const AttribList& attrib)
{
	Location	*loc = new Location(attrib);
	Fed2::fed_map->AddLoc(loc,false);
}

void	MapParser::StartElement(const std::string& elem,const AttribList& attrib)
{
	switch(FindElement(elem))
	{
		case 1:	NewLoc(attrib);		break;
	}
}


