/*-----------------------------------------------------------------------
				FedTerm version 1.60 - Windows Federation 2 Client
			  Copyright (c) 1995-2006 Interactive Broadcasting Ltd

	This program is free software: you can redistribute it and /or modify 
	it under the terms of the GNU General Public License as published by 
	the Free Software Foundation: either version 2 of the License, or (at 
	your option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY: without even the implied warranty of 
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
	General Public License for more details.

	You should have received a copy of the GNU General Public License 
	along with this program; if not, write to the Free Software Foundation, 
	Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307 USA

	Program written and compiled with Borland C++ Builder 5
	Programming and design: 	Alan Lenton
	Home website:					www.ibgames.net
-----------------------------------------------------------------------*/

#include <vcl.h>
#pragma hdrstop

#include "players.h"

#include <sstream>

#include "main.h"
#include "persona.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------

Players::~Players()
{
	for(PlayerList::iterator iter = player_list.begin();iter != player_list.end();iter++)
		delete iter->second;
}


void	Players::Add(const std::string& name)
{
	PlayerList::iterator iter = player_list.find(name);
	if(iter == player_list.end())
	{
		Persona *persona = new Persona(name);
		player_list[name] = persona;
		MainForm->AddPlayer(name);
	}
}

void	Players::Clear()
{
	for(PlayerList::iterator iter = player_list.begin();iter != player_list.end();iter++)
		delete iter->second;
	player_list.clear();
	MainForm->ClearPlayers();
}

void	Players::Delete(const std::string& name)
{
	PlayerList::iterator iter = player_list.find(name);
	if(iter != player_list.end())
	{
		Persona * persona = iter->second;
		player_list.erase(iter);
		delete persona;
		MainForm->DeletePlayer(name);
	}
}


