/*-----------------------------------------------------------------------
				FedTerm version 1.60 - Windows Federation 2 Client
			  Copyright (c) 1995-2006 Interactive Broadcasting Ltd

	This program is free software: you can redistribute it and /or modify 
	it under the terms of the GNU General Public License as published by 
	the Free Software Foundation: either version 2 of the License, or (at 
	your option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY: without even the implied warranty of 
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
	General Public License for more details.

	You should have received a copy of the GNU General Public License 
	along with this program; if not, write to the Free Software Foundation, 
	Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307 USA

	Program written and compiled with Borland C++ Builder 5
	Programming and design: 	Alan Lenton
	Home website:					www.ibgames.net
-----------------------------------------------------------------------*/

#ifndef SERVERPARSER_H
#define SERVERPARSER_H

#include "xml.h"

class AccountRec;
class	Location;

class ServerParser : public XMLParser
{
private:
	static const int	NOT_AN_ELEMENT;
	static const std::string	elements[];

	enum	text_states
	{
		CLEAR, DEFAULT, NEW_LOC, ADD_PLAYER, DEL_PLAYER, ADD_CONTENTS,
		NEW_MAP, REMOVE_CONTENTS, MAP_INFO, ADD_FACTORY, INFRA_UPDATE,
		UPDATE_WORKERS, REMOVE_FACTORY, STATS, SHIP_STATS, TB, NO_OP,
		SPYNET_START, SPYNET, EX_START, EXAMINE
	};

	text_states	status;
	Location *current_loc;
	std::string	tb_name;
	std::string	tb_data;

	int	FindElement(const std::string& elem);

	void	AddContents(const AttribList& attrib);
	void	AddPlayer(const AttribList& attrib);
	void	DeletePlayer(const AttribList& attrib);
	void	EndNewLoc();
	void	Exchange(const AttribList& attrib);
	void	ExchangeBuy(const AttribList& attrib);
	void	ExchangeSell(const AttribList& attrib);
	void	LoadSpynetPicture(const std::string& name);
	void	NewLocation(const AttribList& attrib);
	void	NewMap(const AttribList& attrib);
	void	PlayerStats(const AttribList& attrib);
	void	PlayFX(const AttribList& attrib);
	void	ProcessShipStats(const AttribList& attrib);
	void	RemoveContents(const AttribList& attrib);
	void	StartDisplay(const std::string& caption,const std::string& name);
	void	StartExamine(const AttribList& attrib);
	void	StartSpynet(const AttribList& attrib);
	void	StartTightBeam(const AttribList& attrib);

protected:
	void	StartElement(const std::string& elem,const AttribList& attrib);
	void	EndElement(const std::string& elem);
	void	TextData(const std::string& text);

public:
	ServerParser(const std::string& f_name);
	virtual ~ServerParser();
};

#endif

