/*-----------------------------------------------------------------------
				FedTerm version 1.60 - Windows Federation 2 Client
			  Copyright (c) 1995-2006 Interactive Broadcasting Ltd

	This program is free software: you can redistribute it and /or modify 
	it under the terms of the GNU General Public License as published by 
	the Free Software Foundation: either version 2 of the License, or (at 
	your option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY: without even the implied warranty of 
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
	General Public License for more details.

	You should have received a copy of the GNU General Public License 
	along with this program; if not, write to the Free Software Foundation, 
	Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307 USA

	Program written and compiled with Borland C++ Builder 5
	Programming and design: 	Alan Lenton
	Home website:					www.ibgames.net
-----------------------------------------------------------------------*/

#include <vcl.h>
#pragma hdrstop

#include "ship_stats.h"

#include "main.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------

ShipStats::ShipStats(const AttribList& attrib)
{
	XMLParser::FindAttrib(attrib,"class",class_name);
	MainForm->DisplayShipClass(class_name);
}


void	ShipStats::Clear()
{
	class_name = "";
	hull[CURRENT] = hull[MAXIMUM] = 0;
	shields[CURRENT] = shields[MAXIMUM] = 0;
	engines[CURRENT] = engines[MAXIMUM] = 0;
	fuel[CURRENT] = fuel[MAXIMUM] = 0;
	computer[CURRENT] = computer[MAXIMUM] = 0;
	hold[CURRENT] = hold[MAXIMUM] = 0;
	MainForm->ClearAvatarShipDisplay();
}
 
void	ShipStats::NewStatSelect(const std::string& stat_name)
{
	static const std::string	el_names[] =
	{
		"Hull", "Shields", "Engines", "Fuel", "Computer", "Cargo Space",		//  0- 5
		 " "
	};


	int	stat_number = 99999;
	for(int count = 0;el_names[count] != " ";count++)
	{
		if(el_names[count] == stat_name)
		{
			stat_number = count;
			break;
		}
	}

	switch(stat_number)
	{
		case	0:	MainForm->UpdateShipStatBox(" Hull ",hull[CURRENT],hull[MAXIMUM]);						break;
		case	1:	MainForm->UpdateShipStatBox(" Shields ",shields[CURRENT],shields[MAXIMUM]);			break;
		case	2:	MainForm->UpdateShipStatBox(" Engines ",engines[CURRENT],engines[MAXIMUM]);			break;
		case	3:	MainForm->UpdateShipStatBox(" Fuel ",fuel[CURRENT],fuel[MAXIMUM]);						break;
		case	4:	MainForm->UpdateShipStatBox(" Computer ",computer[CURRENT],computer[MAXIMUM]);		break;
		case	5:	MainForm->UpdateShipStatBox(" Cargo Space Left ",hold[CURRENT],hold[MAXIMUM]);	break;
		default:	MainForm->UpdateShipStatBox("",0,100);																break;
	}
}

void	ShipStats::Process(const AttribList& attrib)
{
	static const std::string	el_names[] =
	{
		"hull", "shields", "engines", "fuel", "computer", "cargo",		//  0- 5
		"navcomp", "customs-cert", "ship", 			  							//	 6- 8
		 " "
	};

	std::string	ship_class;
	XMLParser::FindAttrib(attrib,"class",ship_class);
	if(ship_class != "")
	{
		class_name = ship_class;
		MainForm->DisplayShipClass(class_name);
		return;
	}

	int maximum = XMLParser::FindNumAttrib(attrib,"max",0);
	int current = XMLParser::FindNumAttrib(attrib,"cur",0);
	std::string	stat;
	XMLParser::FindAttrib(attrib,"stat",stat);

	int stat_num = 99999;
	for(int count = 0;el_names[count] != " ";count++)
	{
		if(el_names[count] == stat)
		{
			stat_num = count;
			break;
		}
	}

	switch(stat_num)
	{
		case 0:  hull[MAXIMUM] = maximum;
					hull[CURRENT] = current;
					MainForm->DisplayShipHull(maximum,current);
					break;
		case 1:  shields[MAXIMUM] = maximum;
					shields[CURRENT] = current;
					MainForm->DisplayShipShields(maximum,current);
					break;
		case 2:  engines[MAXIMUM] = maximum;
					engines[CURRENT] = current;
					MainForm->DisplayShipEngines(maximum,current);
					break;
		case 3:  fuel[MAXIMUM] = maximum;
					fuel[CURRENT] = current;
					MainForm->DisplayShipFuel(maximum,current);
					break;
		case 4:  computer[MAXIMUM] = maximum;
					computer[CURRENT] = current;
					MainForm->DisplayShipComputer(maximum,current);
					break;
		case 5:  hold[MAXIMUM] = maximum;
					hold[CURRENT] = current;
					MainForm->DisplayShipCargo(maximum,current);
					break;
		case 6:  MainForm->DisplayShipNavComp();
					break;
		case 7:  MainForm->DisplayShipCustomsCert();
					break;
		case 8:  MainForm->DisplayShipStats();
					break;
	}
}



